%% Figure 3 - Gibbs and Kulish (2017)
% This figure compares and unanticipated to anticipated disinflations when
% lambda = 0.5. The anticpation is 2 quarters.

%% Options

% Note that this option is commented out in runSet.m
SET.options.country = 'USA';
runSet;

SET.param.Delta_ppi = 10;
SET.options.draws   = 750;
SET.param.lambda     = 0.33;

%% Unanticipated
SET.options.unanticipated = 1; % Set to 1 for unanticipated and 0 for anticipated. 
SET.options.anticipated   = 1 - SET.options.unanticipated ; 

out = SR(SET)

%% Ananticipated
SET.options.unanticipated = 0; % Set to 1 for unanticipated and 0 for anticipated. 
SET.options.anticipated   = 1 - SET.options.unanticipated ; 

out_2 = SR(SET)

%% Figure 3

figure(3)
histogram(out.SR.Ycom.draws,50,'Normalization','pdf')
axis([-4 8 0 0.8])
hold on
histogram(out_2.SR.Ycom.draws,50,'Normalization','pdf')
axis([-4 8 0 0.8])


%% Summary Statistics


disp(' ')
disp('Unanticipated')
m_re = mean(out.SR.Ycom.draws);
m_out = [' Mean:     ', num2str(m_re)];
disp(m_out)
s_re = std(out.SR.Ycom.draws);
s_out = [' St. Dev:  ', num2str(s_re)];
disp(s_out)
k_re = skewness(out.SR.Ycom.draws);
k_out = [' Skewness: ', num2str(k_re)];
disp(k_out)
kr_re = kurtosis(out.SR.Ycom.draws);
kr_out = [' Kurtosis: ', num2str(kr_re)];
disp(kr_out)

disp(' ')
disp('Anticipated')
m_re = mean(out_2.SR.Ycom.draws);
m_out = [' Mean:     ', num2str(m_re)];
disp(m_out)
s_re = std(out_2.SR.Ycom.draws);
s_out = [' St. Dev:  ', num2str(s_re)];
disp(s_out)
k_re = skewness(out_2.SR.Ycom.draws);
k_out = [' Skewness: ', num2str(k_re)];
disp(k_out)
kr_re = kurtosis(out_2.SR.Ycom.draws);
kr_out = [' Kurtosis: ', num2str(kr_re)];
disp(kr_out)

disp(' ')
disp('RE Unanticipated')
m_re = mean(out.SR.RE.draws);
m_out = [' Mean:     ', num2str(m_re)];
disp(m_out)
s_re = std(out.SR.RE.draws);
s_out = [' St. Dev:  ', num2str(s_re)];
disp(s_out)
k_re = skewness(out.SR.RE.draws);
k_out = [' Skewness: ', num2str(k_re)];
disp(k_out)
kr_re = kurtosis(out.SR.RE.draws);
kr_out = [' Kurtosis: ', num2str(kr_re)];
disp(kr_out)

disp(' ')
disp('RE Anticipated')
m_re = mean(out_2.SR.RE.draws);
m_out = [' Mean:     ', num2str(m_re)];
disp(m_out)
s_re = std(out_2.SR.RE.draws);
s_out = [' St. Dev:  ', num2str(s_re)];
disp(s_out)
k_re = skewness(out_2.SR.RE.draws);
k_out = [' Skewness: ', num2str(k_re)];
disp(k_out)
kr_re = kurtosis(out_2.SR.RE.draws);
kr_out = [' Kurtosis: ', num2str(kr_re)];
disp(kr_out)