%% Figure 5 - Gibbs & Kulish (2017)
% This figure compares the sacrifice ratios for changes in the size of the
% disinflation for lambda = 1 and lambda= 0.25.

%% Options

% Note that this option is commented out in runSet.m
SET.options.country = 'USA';
runSet;

SET.options.draws   = 750;

SET.options.unanticipated = 1; % Set to 1 for unanticipated and 0 for anticipated. 
SET.options.anticipated   = 1 - SET.options.unanticipated ; 

SET.param.lambda     = 0.25;

%% SET.param.Delta_ppi = 10;

SET.param.Delta_ppi = 10;

out = SR(SET)

%% SET.param.Delta_ppi = 5;

SET.param.Delta_ppi = 5;

out_2 = SR(SET)

%% Figure 5

figure(5)
subplot(1,2,1)
histogram(out.SR.RE.draws,50,'Normalization','pdf')
axis([-2 4 0 1.4])
hold on
histogram(out_2.SR.RE.draws,50,'Normalization','pdf')
axis([-2 4 0 1.4])
subplot(1,2,2)
histogram(out.SR.Ycom.draws,25,'Normalization','pdf')
axis([-5 20 0 0.45])
hold on
histogram(out_2.SR.Ycom.draws,25,'Normalization','pdf')
axis([-5 20 0 0.45])


%% Summary Statistics


disp(' ')
disp('10% Disinflation - RE')
m_re = mean(out.SR.RE.draws);
m_out = [' Mean:     ', num2str(m_re)];
disp(m_out)
s_re = std(out.SR.RE.draws);
s_out = [' St. Dev:  ', num2str(s_re)];
disp(s_out)
k_re = skewness(out.SR.RE.draws);
k_out = [' Skewness: ', num2str(k_re)];
disp(k_out)
kr_re = kurtosis(out.SR.RE.draws);
kr_out = [' Kurtosis: ', num2str(kr_re)];
disp(kr_out)

disp(' ')
disp('10% Disinflation - Lambda=0.5')
m_re = mean(out.SR.Ycom.draws);
m_out = [' Mean:     ', num2str(m_re)];
disp(m_out)
s_re = std(out.SR.Ycom.draws);
s_out = [' St. Dev:  ', num2str(s_re)];
disp(s_out)
k_re = skewness(out.SR.Ycom.draws);
k_out = [' Skewness: ', num2str(k_re)];
disp(k_out)
kr_re = kurtosis(out.SR.Ycom.draws);
kr_out = [' Kurtosis: ', num2str(kr_re)];
disp(kr_out)

disp(' ')
disp('5% Disinflation - RE')
m_re = mean(out_2.SR.RE.draws);
m_out = [' Mean:     ', num2str(m_re)];
disp(m_out)
s_re = std(out_2.SR.RE.draws);
s_out = [' St. Dev:  ', num2str(s_re)];
disp(s_out)
k_re = skewness(out_2.SR.RE.draws);
k_out = [' Skewness: ', num2str(k_re)];
disp(k_out)
kr_re = kurtosis(out_2.SR.RE.draws);
kr_out = [' Kurtosis: ', num2str(kr_re)];
disp(kr_out)

disp(' ')
disp('5% Disinflation - Lambda=0.5')
m_re = mean(out_2.SR.Ycom.draws);
m_out = [' Mean:     ', num2str(m_re)];
disp(m_out)
s_re = std(out_2.SR.Ycom.draws);
s_out = [' St. Dev:  ', num2str(s_re)];
disp(s_out)
k_re = skewness(out_2.SR.Ycom.draws);
k_out = [' Skewness: ', num2str(k_re)];
disp(k_out)
kr_re = kurtosis(out_2.SR.Ycom.draws);
kr_out = [' Kurtosis: ', num2str(kr_re)];
disp(kr_out)