function out = SR_reg(SET)

%  SR_reg.m
%
% ------------------------------------------------------------------- %

%% Order of Variables in y(t)

r    = SET.variable.r;
yhat = SET.variable.yhat;
x    = SET.variable.x;
ppi  = SET.variable.ppi;
ppi_target = SET.variable.ppi_target;
g  = SET.variable.g ;
om = SET.variable.om;
m  = SET.variable.m;
a  = SET.variable.a;
e  = SET.variable.e;
v  = SET.variable.v;
z  = SET.variable.z;
const = SET.variable.const;

n = const;

% Order of Shocks in eps(t)
ea = 1;  ee = 2;
eom = 3; er = 4;
etarget = 5; ev = 6; ez = 7;

% Dimension of eps(t)
nshocks = 7;

%% Parameters
beta   = SET.param.beta;
zbar   = SET.param.zbar;
ppibar = SET.param.ppibar;
rho_a  = SET.param.rho_a;
rho_e  = SET.param.rho_e;
rho_z  = SET.param.rho_z;
rho_v  = SET.param.rho_v;
omeg   = SET.param.omeg;
psi    = SET.param.psi;
mu_a   = SET.param.mu_a;
mu_e   = SET.param.mu_e;
mu_z   = SET.param.mu_z;
mu_v   = SET.param.mu_v;
mu_a_f = SET.param.mu_a_f;
mu_e_f = SET.param.mu_e_f;
mu_z_f = SET.param.mu_z_f;
mu_v_f = SET.param.mu_v_f;


rho_r   = SET.param.rho_r;
rho_pi  = SET.param.rho_pi;
rho_g   = SET.param.rho_g;
rho_x   = SET.param.rho_x;
rho_target = SET.param.rho_target;
rho_r_f    = SET.param.rho_r_f ;
rho_pi_f   = SET.param.rho_pi_f;
rho_g_f    = SET.param.rho_g_f;
rho_x_f    = SET.param.rho_x_f;
rho_target_f = SET.param.rho_target_f;

rho_om = SET.param.rho_om;
rho_om_pi = SET.param.rho_om_pi;
rho_om_g = SET.param.rho_om_g;
rho_om_x = SET.param.rho_om_x;
rho_om_f = SET.param.rho_om_f;
rho_om_pi_f = SET.param.rho_om_pi_f;
rho_om_g_f = SET.param.rho_om_g_f;
rho_om_x_f = SET.param.rho_om_x_f;

add_sig_a = SET.param.sig_sig_a;     
add_sig_e = SET.param.sig_sig_e;     
add_sig_z = SET.param.sig_sig_z;     
add_sig_r = SET.param.sig_sig_r;     
add_sig_om = SET.param.sig_sig_om;     
add_sig_target = SET.param.sig_sig_target; 
add_sig_v = SET.param.sig_sig_v;     

adjust = SET.param.adjust;

sig_a = SET.param.sig_a - adjust*add_sig_a;
sig_e = SET.param.sig_e - adjust*add_sig_e;
sig_z = SET.param.sig_z - adjust*add_sig_z;
sig_r = SET.param.sig_r - adjust*add_sig_r;
sig_om = SET.param.sig_om - adjust*add_sig_om;
sig_target = SET.param.sig_target - adjust*add_sig_target;
sig_v = SET.param.sig_v - adjust*add_sig_v;



Delta_ppi = SET.param.Delta_ppi;

gain = SET.param.gain;
lambda = SET.param.lambda;


OMEGA = diag([sig_a, sig_e, sig_om, sig_r, sig_target, sig_v, sig_z]).^2;

Rbar   =  (exp(zbar)*exp(ppibar)/beta);
r_ss   = zbar + ppibar - log(beta);
ppibar_f = ppibar-Delta_ppi/400;
Rbar_f   =  (exp(zbar)*exp(ppibar_f)/beta);
r_ss_f   = zbar + ppibar_f - log(beta);


money_rule = SET.options.money_rule;
taylor_rule = SET.options.taylor_rule;
money_rule_f = SET.options.money_rule_f;
taylor_rule_f = SET.options.taylor_rule_f;

shocks_on = SET.options.stochastic;
draws = SET.options.draws;

kk = SET.options.randnstate ;

set_states = SET.options.states;

T = SET.options.T;
T_a = SET.options.T_a;
T_star = SET.options.T_star;
anticipated = SET.options.anticipated;
unanticipated = 1 - anticipated;

%Ball SR options
sample_size = SET.options.Ball_sample;
Min_Size_Disin = SET.options.min_dis_size;
dates_disin = SET.options.dates_disin; 

SaR_draws_non = zeros(draws,1); % Vector of Sacrifice ratios
SaR_draws_RE = zeros(draws,1); % Vector of Sacrifice ratios
SuR_draws_RE = zeros(draws,1); % Vector of Success ratios
SaR_draws_RE_avg = zeros(draws,1);
SuR_draws_RE_avg = zeros(draws,1);
SaR_draws_Ycom = zeros(draws,1);
SuR_draws_Ycom = zeros(draws,1);
SaR_draws_Ycom_avg = zeros(draws,1);
SuR_draws_Ycom_avg = zeros(draws,1);
bigYcom = zeros(n,T,draws);
bigYre = zeros(n,T,draws);
bigYnon = zeros(n,T,draws);
T_draws_RE = zeros(draws,1);
T_draws_Ycom = zeros(draws,1);
T_draws_Ynon = zeros(draws,1);


Dates_of_Dis_Ycom  =  zeros(dates_disin,2,draws);
Dates_of_Dis_Y     =  zeros(dates_disin,2,draws);

Ball_SaR_draws_RE     = zeros(draws,dates_disin);
Ball_SaR_draws_Ycom   = zeros(draws,dates_disin);

Size_Noise_Dis_Ycom  = zeros(draws,dates_disin);
Size_Noise_Dis_Y  = zeros(draws,dates_disin);

Dur_Noise_Dis_Ycom  = zeros(draws,dates_disin);
Dur_Noise_Dis_Y  = zeros(draws,dates_disin);

Peak_Noise_Dis_Ycom  = zeros(draws,dates_disin);
Peak_Noise_Dis_Y  = zeros(draws,dates_disin);

Size_Policy_Dis_Ycom = zeros(draws,1);
Size_Policy_Dis_Y = zeros(draws,1);

Duration_Policy_Dis_Ycom = zeros(draws,1);
Duration_Policy_Dis_Y = zeros(draws,1);

Peak_Policy_Dis_Ycom = zeros(draws,1);
Peak_Policy_Dis_Y = zeros(draws,1);

Policy_SR_Ycom = zeros(draws,1);
Policy_SR_Y = zeros(draws,1);

Sd_inf_Policy_Dis_Ycom = zeros(draws,1);
Sd_inf_Policy_Dis_Y = zeros(draws,1);


%Initial Learning Beliefs

%IQB = Initial_Beliefs(SET);


%% Error messages and controls
if T_a > T_star
    disp('Error: Announcement occurs after the regime change')
    disp('T_a > T_star')
    return
end

if unanticipated
    disp('Unanticipated change')
    T_a = T_star;
end

if SET.options.display == 1
    
    disp('-----------              -----------')
    disp('------ Type of Disinflation --------')
    disp('-----------              -----------')
    if anticipated
        disp('Anticipated disinflation')
        disp('                        ')
        disp('Time of announcement:')
        disp(T_a)
        disp('Time of implementation:')
        disp(T_star)
        disp('                        ')
        disp('Initial inflation target')
        disp(ppibar*400)
        disp('Final inflation target')
        disp(ppibar_f*400)
        disp('Delta ppi')
        disp(Delta_ppi)
        disp('                        ')
        disp('Weight on RE: lambda:   ')
        disp(lambda)
        disp('Gain:                   ')
        disp(gain)
    else
        disp('Unanticipated disinflation')
        disp('                        ')
        disp('Time of implementation:')
        disp(T_star)
        disp('                        ')
        disp('Initial inflation target')
        disp(ppibar*400)
        disp('Final inflation target')
        disp(ppibar_f*400)
        disp('Delta ppi')
        disp(Delta_ppi)
        disp('Weight on RE: lambda:   ')
        disp(lambda)
        disp('Gain:                   ')
        disp(gain)
    end
else disp('Computing...')
    
end

%% Main Loop

for  i_ = 1:draws
    
    randn('state',kk + i_);
    eps = shocks_on*OMEGA.^.5 * randn(nshocks,T);
    
    
    
    %% Initial structure
    % Set up Binder Pesaran matrices
    A0 = zeros(n,n);
    A1 = zeros(n,n);
    B0 = zeros(n,n);
    D0 = zeros(n,nshocks);
    
    eq_num = 1;
    
    % Euler equation
    % x(t) = (r-pi) - (r(t) - Et pi(t+1)) + Et x(t+1) + (1-rho_a)a(t)
    A0(eq_num,r) = 1;
    A0(eq_num,a) = -(1-rho_a)*(1-omeg);
    A0(eq_num,x) = 1;
    A0(eq_num,const) = ppibar - r_ss;
    B0(eq_num,x) = 1;
    B0(eq_num,ppi) = 1;
    
    eq_num = eq_num + 1;
    
    % Phillips Curve
    % pi(t) = (1-beta)*ppibar + beta*Et pi(t+1) + psi x(t) - e(t)
    A0(eq_num,e) = 1;
    A0(eq_num,x) = -psi;
    A0(eq_num,ppi) = 1;
    A0(eq_num,const) = -(1-beta)*ppibar;
    B0(eq_num,ppi) = beta;
    
    eq_num = eq_num + 1;
    
    % Monetary Policy Rule
    % r(t) = (1-rho_r)r_ss + rho_r r(t-1) + rho_pi*(pi(t)-pitarget(t)) + rho_g*(g-zbar) + rho_x*x(t) + er(t)
    A0(eq_num,r)          = 1 * taylor_rule;
    A0(eq_num,x)          = -rho_x * taylor_rule;
    A0(eq_num,ppi)        = -rho_pi * taylor_rule;
    A0(eq_num,ppi_target) = rho_pi * taylor_rule;
    A0(eq_num,g)          = -rho_g * taylor_rule;
    A0(eq_num,const) = -((1-rho_r)*r_ss - rho_g*zbar) * taylor_rule - ((1-rho_om)*(ppibar + zbar) - rho_om_g*zbar) * money_rule;
    A1(eq_num,r)     = rho_r * taylor_rule;
    D0(eq_num,er)    = 1 * taylor_rule;
    
    A0(eq_num,om)  = money_rule*1;
    A1(eq_num,om)  = rho_om*money_rule;
    A1(eq_num,x)   = rho_om_x*money_rule;
    A1(eq_num,ppi)  = rho_om_pi*money_rule;
    A1(eq_num,ppi_target) = -rho_om_pi*money_rule;
    A1(eq_num,g)   = rho_om_g*money_rule;
    A0(eq_num,const) =  -((1-rho_r)*r_ss - rho_g*zbar) * taylor_rule - ((1-rho_om)*(ppibar + zbar) - rho_om_g*zbar) * money_rule;
    D0(eq_num,eom) = 1* money_rule;
    
    eq_num = eq_num + 1;
    
    % Output gap
    % x(t) = yhat(t) - omeg*a(t)
    
    A0(eq_num,x) = 1;
    A0(eq_num,yhat) = -1;
    A0(eq_num,a) = omeg;
    
    eq_num = eq_num + 1;
    
    % Output growth
    % g(t) = yhat - yhat(-1) + z(t)
    
    A0(eq_num,g) = 1;
    A0(eq_num,yhat) = -1;
    A1(eq_num,yhat) = -1;
    A0(eq_num,z) = -1;
    
    eq_num = eq_num + 1;
    
    % Definition of money growth
    
    A0(eq_num,om)  = 1;
    A0(eq_num,m)   = -1;
    A1(eq_num,m)   = 1;
    A0(eq_num,ppi) = -1;
    A0(eq_num,z) = -1;
    
    eq_num = eq_num + 1;
    
    % Money demand
    
    A0(eq_num,m) = 1;
    A0(eq_num,yhat) = -1;
    A0(eq_num,a) = 1;
    A0(eq_num,r) = 1/(Rbar -1);
    A0(eq_num,v) = -1;
    A0(eq_num,const) = -(1/(Rbar -1))*r_ss;
    
    eq_num = eq_num + 1;
    
    % Inflation target
    
    A0(eq_num,ppi_target) = 1;
    A1(eq_num,ppi_target) = rho_target;
    D0(eq_num,ea) = mu_a;
    D0(eq_num,ee) = mu_e;
    D0(eq_num,ez) = mu_z;
    D0(eq_num,ev) = mu_v;
    D0(eq_num,etarget) = 1;
    A0(eq_num,const) = -(1-rho_target)*ppibar;
    
    eq_num = eq_num + 1;
    
    % AR equations
    
    A0(eq_num,a) = 1;
    A1(eq_num,a) = rho_a;
    D0(eq_num,ea) = 1;
    
    eq_num = eq_num + 1;
    
    A0(eq_num,e) = 1;
    A1(eq_num,e) = rho_e;
    D0(eq_num,ee) = 1;
    
    eq_num = eq_num + 1;
    
    A0(eq_num,v) = 1;
    A1(eq_num,v) = rho_v;
    D0(eq_num,ev) = 1;
    
    eq_num = eq_num + 1;
    
    A0(eq_num,z) = 1;
    A1(eq_num,z) = rho_z;
    A0(eq_num,const) = -(1-rho_z)*zbar;
    D0(eq_num,ez) = 1;
    
    eq_num = eq_num + 1;
    
    % Constant
    
    A0(eq_num,const) = 1;
    A1(eq_num,const) = 1;
    
    
    % AR(1)s are in y(t) so
    Gamma = zeros(nshocks);
    % D0 is entered above;
    D2 = zeros(n, nshocks);
    % Solution of Initial Regime
    [Q, G, unique, rc, iter] = smatsbp(A0,A1,B0,D0,D2,Gamma);
    % Steady state of Initial Regime
    P = Q(1:end-1,1:end-1);
    C = Q(1:end-1,end);
    y_ss = (eye(n-1)-P)\C;
    y_ss(n) = 1;
    
    IQB = Q;
    %% Final Structure
    % Set up Binder Pesaran matrices
    A0f = zeros(n,n);
    A1f = zeros(n,n);
    B0f = zeros(n,n);
    D0f = zeros(n,nshocks);
    
    eq_num = 1;
    
    % Euler equation
    % x(t) = (r-pi) - (r(t) - Et pi(t+1)) + Et x(t+1) + (1-rho_a)a(t)
    A0f(eq_num,r) = 1;
    A0f(eq_num,a) = -(1-rho_a)*(1-omeg);
    A0f(eq_num,x) = 1;
    A0f(eq_num,const) = ppibar_f - r_ss_f;
    B0f(eq_num,x) = 1;
    B0f(eq_num,ppi) = 1;
    
    eq_num = eq_num + 1;
    
    % Phillips Curve
    % pi(t) = (1-beta)*ppibar_f + beta*Et pi(t+1) + psi x(t) - e(t)
    A0f(eq_num,e) = 1;
    A0f(eq_num,x) = -psi;
    A0f(eq_num,ppi) = 1;
    A0f(eq_num,const) = -(1-beta)*ppibar_f;
    B0f(eq_num,ppi) = beta;
    
    eq_num = eq_num + 1;
    
    % Monetary Policy Rule
    % r(t) = r + rho_r r(t-1) + rho_pi*(pi(t)-pi) + rho_g*(g-zbar) + rho_x*x(t) + er(t)
    A0f(eq_num,r)     = taylor_rule_f*1;
    A0f(eq_num,x)     = -rho_x_f*taylor_rule_f;
    A0f(eq_num,ppi)   = -rho_pi_f*taylor_rule_f;
    A0f(eq_num,ppi_target) = rho_pi_f*taylor_rule_f;
    A0f(eq_num,g)     = -rho_g_f*taylor_rule_f;
    A0f(eq_num,const) = -((1-rho_r_f)*r_ss_f-rho_g_f*zbar)*taylor_rule_f - ((1-rho_om_f)*(ppibar_f + zbar) - rho_om_g_f*zbar) * money_rule_f;
    A1f(eq_num,r)     = rho_r_f*taylor_rule_f;
    D0f(eq_num,er)    = 1*taylor_rule_f;
    
    A0f(eq_num,om)  = money_rule_f*1;
    A1f(eq_num,om)  = rho_om_f*money_rule_f;
    A1f(eq_num,x)   = rho_om_x_f*money_rule_f;
    A1f(eq_num,ppi)  = rho_om_pi_f*money_rule_f;
    A1f(eq_num,ppi_target) = -rho_om_pi_f*money_rule_f;
    A1f(eq_num,g)   = rho_om_g_f*money_rule_f;
    A0f(eq_num,const) = -((1-rho_r_f)*r_ss_f-rho_g_f*zbar)*taylor_rule_f-((1-rho_om_f)*(ppibar_f + zbar) - rho_om_g_f*zbar) * money_rule_f;
    D0f(eq_num,eom) = 1* money_rule_f;
    
    
    eq_num = eq_num + 1;
    
    % Output gap
    % x(t) = yhat(t) - omeg*a(t)
    
    A0f(eq_num,x) = 1;
    A0f(eq_num,yhat) = -1;
    A0f(eq_num,a) = omeg;
    
    eq_num = eq_num + 1;
    
    % Output growth
    % g(t) = yhat - yhat(-1) + z(t)
    
    A0f(eq_num,g) = 1;
    A0f(eq_num,yhat) = -1;
    A1f(eq_num,yhat) = -1;
    A0f(eq_num,z) = -1;
    
    eq_num = eq_num + 1;
    
    % Definition of money growth
    
    A0f(eq_num,om)  = 1;
    A0f(eq_num,m)   = -1;
    A1f(eq_num,m)   = 1;
    A0f(eq_num,ppi) = -1;
    A0f(eq_num,z) = -1;
    
    eq_num = eq_num + 1;
    
    % Money demand
    
    A0f(eq_num,m) = 1;
    A0f(eq_num,yhat) = -1;
    A0f(eq_num,a) = 1;
    A0f(eq_num,r) = 1/(Rbar -1);
    A0f(eq_num,v) = -1;
    A0f(eq_num,const) = -(1/(Rbar -1))*r_ss_f;
    
    eq_num = eq_num + 1;
    
    % Inflation target
    
    A0f(eq_num,ppi_target) = 1;
    A1f(eq_num,ppi_target) = rho_target_f;
    D0f(eq_num,ea) = mu_a_f;
    D0f(eq_num,ee) = mu_e_f;
    D0f(eq_num,ez) = mu_z_f;
    D0f(eq_num,ev) = mu_v_f;
    D0f(eq_num,etarget) = 0; %Assume no shock to inflation target.
    A0f(eq_num,const) = -(1-rho_target_f)*ppibar_f;
    
    eq_num = eq_num + 1;
    
    % AR equations
    
    A0f(eq_num,a) = 1;
    A1f(eq_num,a) = rho_a;
    D0f(eq_num,ea) = 1;
    
    eq_num = eq_num + 1;
    
    A0f(eq_num,e) = 1;
    A1f(eq_num,e) = rho_e;
    D0f(eq_num,ee) = 1;
    
    eq_num = eq_num + 1;
    
    A0f(eq_num,v) = 1;
    A1f(eq_num,v) = rho_v;
    D0f(eq_num,ev) = 1;
    
    eq_num = eq_num + 1;
    
    A0f(eq_num,z) = 1;
    A1f(eq_num,z) = rho_z;
    A0f(eq_num,const) = -(1-rho_z)*zbar;
    D0f(eq_num,ez) = 1;
    
    eq_num = eq_num + 1;
    
    % Constant
    
    A0f(eq_num,const) = 1;
    A1f(eq_num,const) = 1;
    
    
    % AR(1)s are in y(t) so
    Gammaf = zeros(nshocks);
    % D0f is entered above;
    D2f = zeros(n, nshocks);
    % Solution of Initial Regime
    [Qf, Gf, uniquef, rcf, iter] = smatsbp(A0f,A1f,B0f,D0f,D2f,Gammaf);
    % Steady state of Initial Regime
    Pf = Qf(1:end-1,1:end-1);
    Cf = Qf(1:end-1,end);
    y_ss_f = (eye(n-1)-Pf)\Cf;
    y_ss_f(n) = 1;
    
    %% Transition
    
    if anticipated
        % periods Tm to T_star-1
        
        A = A0\A1;
        A0inv = inv(A0);
        B = A0\B0;
        
        Qat = zeros(n,n,T_star-T_a);
        Gat = zeros(n,nshocks,T_star-T_a);
        
        % Boundary condition
        Qat(:,:,end) = (eye(n)-B*Qf)\A;
        Gat(:,:,end) = (eye(n)-B*Qf)\A0inv*D0;
        
        % Sequence of reduced form matrices
        for t = T_star-T_a-1:-1:1
            Qat(:,:,t) = (eye(n)-B*Qat(:,:,t+1))\A;
            Gat(:,:,t) = (eye(n)-B*Qat(:,:,t+1))\A0inv*D0;
        end
        
        Qt = zeros(n,n,T);
        Gt = zeros(n,nshocks,T);
        
        for t = 1:T_a-1
            Qt(:,:,t) = Q;
            Gt(:,:,t) = G;
        end
        for t = T_a:T_star-1
            Qt(:,:,t) = Qat(:,:,t-T_a+1);
            Gt(:,:,t) = Gat(:,:,t-T_a+1);
        end
        for t = T_star:T
            Qt(:,:,t) = Qf ;
            Gt(:,:,t) = Gf ;
        end
        
    else
        A = A0\A1;
        A0inv = inv(A0);
        B = A0\B0;
        
        Qt = zeros(n,n,T);
        Gt = zeros(n,nshocks,T);
        
        for t = 1:T_star-1
            Qt(:,:,t) = Q;
            Gt(:,:,t) = G;
        end
        for t = T_star:T
            Qt(:,:,t) = Qf ;
            Gt(:,:,t) = Gf ;
        end
    end
    
    
    %% E-stability
    Af = A0f\A1f;
    Bf = A0f\B0f;
    
    DTQ = @(b) kron(inv(eye(n,n)-B*b)*A,inv(eye(n,n)-B*b)*B*(1-lambda));
    DTQf = @(b) kron(inv(eye(n,n)-Bf*b)*Af,inv(eye(n,n)-Bf*b)*Bf*(1-lambda));
    
    
    condition1 = eig(DTQ(Q));
    condition2 = eig(DTQf(Qf));
    
    if SET.options.display == 1
        if real(max(condition1)) > 1.
            disp('Initial Structure Not E-stable');
        else
            disp('Initial Structure E-stable');
            disp('                          ');
        end;
        
        if real(max(condition2)) > 1.
            disp('Final Structure Not E-stable');
        else
            disp('Final Structure E-stable');
            disp('                          ');
        end;
    end
    
    
    %% Simulation: Combined and REE
    y = zeros(n,T);
    y_non = zeros(n,T);
    y(:,1) = y_ss;
    y_non(:,1) = y_ss;
    
    Q_learn = zeros(n,n,T);
    Q_com = zeros(n,n,T);
    y_com = zeros(n,T);
    
    Q_com(:,:,1) = Q;
    y_com(:,1)=y(:,1);
    
    % Finding relevant states
    
    if strcmp(set_states, 'msv')==1
        toler = 1e-8;
        states = find(sum(abs(Q))>toler);
        states_f = find(sum(abs(Qf))>toler);
        
    elseif strcmp(set_states, 'all')==1
        all = 1:13;
        states = all;
        states_f = states;
        
    elseif strcmp(set_states, 'random')==1
        % Picks Assumes states > nshocks
        states = sort(randsample(states,nshocks));
        states_f = states; % sort(randsample(states_f,nshocks));
        
    elseif strcmp(set_states, 'state_no_target')==1
        states = [1 2 3 4 6 7 8 9 10 11 12 13];
        states_f = [1 2 3 4 6 7 8 9 10 11 12 13];
        
    else
        error('Choose a valid state option');
    end;
    
    if SET.options.display == 1
        disp('States:')
        disp(set_states);
        disp('                          ');
    end
    
    %Set Variances for no shocks
    Variances = [0.0014, 0.0953, 0.0956, 0.0017 ,0.0001 ,0.0012 ,2.1384 ,0.5601 ,0.0048 ,0.0011 ,0.0513 ,0.0003,1];
    
    
    r0 = eye(length(states));
    r0f = eye(length(states_f));
    
    theta_r = IQB(r,states)';
    theta_yhat = IQB(yhat,states)';
    theta_x = IQB(x,states)';
    theta_ppi = IQB(ppi,states)';
    theta_ppi_target = IQB(ppi_target,states)';
    theta_g= IQB(g,states)';
    theta_om = IQB(om,states)';
    theta_m = IQB(m,states)';
    
    temp_r = zeros(1,n);
    temp_r(1,states) = theta_r;
    temp_yhat = zeros(1,n);
    temp_yhat(1,states) = theta_yhat;
    temp_x = zeros(1,n);
    temp_x(1,states) = theta_x;
    temp_ppi = zeros(1,n);
    temp_ppi(1,states) = theta_ppi;
    temp_ppi_target = zeros(1,n);
    temp_ppi_target(1,states) = theta_ppi_target;
    temp_g = zeros(1,n);
    temp_g(1,states) = theta_g;
    temp_om = zeros(1,n);
    temp_om(1,states) = theta_om;
    temp_m = zeros(1,n);
    temp_m(1,states) = theta_m;
    
    
    Q_learn(:,:,1) = [temp_r;
        temp_yhat;
        temp_x;
        temp_ppi;
        temp_ppi_target;
        temp_g;
        temp_om;
        temp_m;
        zeros(1,m), rho_a, zeros(1,4);
        zeros(1,a), rho_e, zeros(1,3);
        zeros(1,e), rho_v, zeros(1,2);
        zeros(1,v), rho_z, (1-rho_z)*zbar;
        zeros(1,z), 1];
    
    Q_learn(:,:,2) = Q_learn(:,:,1);
    
    for t = 2:T_a-1
        
        Q_learn(:,:,t) = [temp_r;
            temp_yhat;
            temp_x;
            temp_ppi;
            temp_ppi_target;
            temp_g;
            temp_om;
            temp_m;
            zeros(1,m), rho_a, zeros(1,4);
            zeros(1,a), rho_e, zeros(1,3);
            zeros(1,e), rho_v, zeros(1,2);
            zeros(1,v), rho_z, (1-rho_z)*zbar;
            zeros(1,z), 1];
        
        
        Q_com(:,:,t) = lambda * Q + (1 - lambda) * Q_learn(:,:,t);
        
        y_com(:,t) = inv(A0-B0*Q_com(:,:,t))*A1*y_com(:,t-1) + (A0-B0*Q_com(:,:,t))\D0*eps(:,t);
        
        
        %Estimating PLM: equation-by-equation RLS
        rr = r0;
        X  = y_com(states,t-1);
        
        if shocks_on
            rrr        = rr + gain * (X*X'-rr) ;
        else
            rrr = diag(Variances(states));
        end
        theta_r    = theta_r + gain * inv(rrr ) * X * (y_com(r,t) - theta_r'*X);
        theta_yhat = theta_yhat + gain * inv(rrr ) * X * (y_com(yhat,t) - theta_yhat'*X);
        theta_x    = theta_x + gain * inv(rrr ) * X * (y_com(x,t) - theta_x'*X);
        theta_ppi  = theta_ppi + gain * inv(rrr ) * X * (y_com(ppi,t) - theta_ppi'*X);
        theta_ppi_target = theta_ppi_target + gain * inv(rrr) * X * (y_com(ppi_target,t) - theta_ppi_target'*X);
        theta_g   = theta_g + gain * inv(rrr ) * X * (y_com(g,t) - theta_g'*X);
        theta_om  = theta_om + gain * inv(rrr) * X * (y_com(om,t) - theta_om'*X);
        theta_m   = theta_m + gain * inv(rrr) * X * (y_com(m,t) - theta_m'*X);
        
        
        temp_r(1,states) = theta_r;
        temp_yhat(1,states) = theta_yhat;
        temp_x(1,states) = theta_x;
        temp_ppi(1,states) = theta_ppi;
        temp_ppi_target(1,states) = theta_ppi_target;
        temp_g(1,states) = theta_g;
        temp_om(1,states) = theta_om;
        temp_m(1,states) = theta_m;
        
        %update beliefs
        r0=rrr;
        
        
    end
    
    
    for t = T_a:T_star-1
        
        Q_learn(:,:,t) = [temp_r;
            temp_yhat;
            temp_x;
            temp_ppi;
            temp_ppi_target;
            temp_g;
            temp_om;
            temp_m;
            zeros(1,m), rho_a, zeros(1,4);
            zeros(1,a), rho_e, zeros(1,3);
            zeros(1,e), rho_v, zeros(1,2);
            zeros(1,v), rho_z, (1-rho_z)*zbar;
            zeros(1,z), 1];
        
        Q_com(:,:,t) = lambda * Qt(:,:,t+1) + (1 - lambda) * Q_learn(:,:,t);
        
        y_com(:,t) = (A0-B0*Q_com(:,:,t))\A1*y_com(:,t-1) + (A0-B0*Q_com(:,:,t))\D0*eps(:,t);
        
        %y_com(:,t) = (A0-B0*Q_com(:,:,t))\A1*y_com(:,t-1) + (lambda * Gt(:,:,t+1) + (1-lambda)*(A0-B0*Q_com(:,:,t))\D0)*eps(:,t);
        
        %Estimating PLM: equation-by-equation RLS
        rr=r0;
        X=y_com(states,t-1);
        
        if shocks_on
            rrr        = rr + gain * (X*X'-rr) ;
        else
            rrr = diag(Variances(states));
        end
        theta_r    = theta_r + gain * inv(rrr) * X * (y_com(r,t) - theta_r'*X);
        theta_yhat = theta_yhat + gain * inv(rrr) * X * (y_com(yhat,t) - theta_yhat'*X);
        theta_x    = theta_x + gain * inv(rrr) * X * (y_com(x,t) - theta_x'*X);
        theta_ppi  = theta_ppi + gain * inv(rrr) * X * (y_com(ppi,t) - theta_ppi'*X);
        theta_ppi_target = theta_ppi_target + gain * inv(rrr) * X * (y_com(ppi_target,t) - theta_ppi_target'*X);
        theta_g   = theta_g + gain * inv(rrr) * X * (y_com(g,t) - theta_g'*X);
        theta_om  = theta_om + gain * inv(rrr) * X * (y_com(om,t) - theta_om'*X);
        theta_m   = theta_m + gain * inv(rrr) * X * (y_com(m,t) - theta_m'*X);
        
        temp_r(1,states) = theta_r;
        temp_yhat(1,states) = theta_yhat;
        temp_x(1,states) = theta_x;
        temp_ppi(1,states) = theta_ppi;
        temp_ppi_target(1,states) = theta_ppi_target;
        temp_g(1,states) = theta_g;
        temp_om(1,states) = theta_om;
        temp_m(1,states) = theta_m;
        
        %update beliefs
        r0=rrr;
        
        
    end
    
    
    theta_r = Q_learn(r,states_f,T_star-1)';
    theta_yhat = Q_learn(yhat,states_f,T_star-1)';
    theta_x = Q_learn(x,states_f,T_star-1)';
    theta_ppi = Q_learn(ppi,states_f,T_star-1)';
    theta_ppi_target = Q_learn(ppi_target,states_f,T_star-1)';
    theta_g= Q_learn(g,states_f,T_star-1)';
    theta_om = Q_learn(om,states_f,T_star-1)';
    theta_m = Q_learn(m,states_f,T_star-1)';
    
    temp_r = Q_learn(r,:,T_star-1);
    temp_r(1,states_f) = theta_r;
    temp_yhat = Q_learn(yhat,:,T_star-1);
    temp_yhat(1,states_f) = theta_yhat;
    temp_x = Q_learn(yhat,:,T_star-1);
    temp_x(1,states_f) = theta_x;
    temp_ppi = Q_learn(ppi,:,T_star-1);
    temp_ppi(1,states_f) = theta_ppi;
    temp_ppi_target = Q_learn(ppi_target,:,T_star-1);
    temp_ppi_target(1,states_f) = theta_ppi_target;
    temp_g = Q_learn(g,:,T_star-1);
    temp_g(1,states_f) = theta_g;
    temp_om = Q_learn(om,:,T_star-1);
    temp_om(1,states_f) = theta_om;
    temp_m = Q_learn(m,:,T_star-1);
    temp_m(1,states_f) = theta_m;
    
    
    
    for t = T_star:T
        
        
        Q_learn(:,:,t) = [temp_r;
            temp_yhat;
            temp_x;
            temp_ppi;
            temp_ppi_target;
            temp_g;
            temp_om;
            temp_m;
            zeros(1,m), rho_a, zeros(1,4);
            zeros(1,a), rho_e, zeros(1,3);
            zeros(1,e), rho_v, zeros(1,2);
            zeros(1,v), rho_z, (1-rho_z)*zbar;
            zeros(1,z), 1];
        
        
        Q_com(:,:,t) = lambda * Qf + (1 - lambda) * Q_learn(:,:,t);
        
        y_com(:,t) = (A0f-B0f*Q_com(:,:,t))\A1f*y_com(:,t-1) + (A0f-B0f*Q_com(:,:,t))\D0f*eps(:,t);
        
        
        %Estimating PLM: equation-by-equation RLS
        rr=r0f;
        X=y_com(states_f,t-1);
        
        if shocks_on
            rrr        = rr + gain * (X*X'-rr) ;
        else
            rrr = diag(Variances(states_f));
        end
        theta_r    = theta_r + gain * inv(rrr) * X * (y_com(r,t) - theta_r'*X);
        theta_yhat = theta_yhat + gain * inv(rrr) * X * (y_com(yhat,t) - theta_yhat'*X);
        theta_x    = theta_x + gain * inv(rrr) * X * (y_com(x,t) - theta_x'*X);
        theta_ppi  = theta_ppi + gain * inv(rrr) * X * (y_com(ppi,t) - theta_ppi'*X);
        theta_ppi_target = theta_ppi_target + gain * inv(rrr) * X * (y_com(ppi_target,t) - theta_ppi_target'*X);
        theta_g   = theta_g + gain * inv(rrr) * X * (y_com(g,t) - theta_g'*X);
        theta_om  = theta_om + gain * inv(rrr) * X * (y_com(om,t) - theta_om'*X);
        theta_m   = theta_m + gain * inv(rrr) * X * (y_com(m,t) - theta_m'*X);
        
        temp_r(1,states_f) = theta_r;
        temp_yhat(1,states_f) = theta_yhat;
        temp_x(1,states_f) = theta_x;
        temp_ppi(1,states_f) = theta_ppi;
        temp_ppi_target(1,states_f) = theta_ppi_target;
        temp_g(1,states_f) = theta_g;
        temp_om(1,states_f) = theta_om;
        temp_m(1,states_f) = theta_m;
        
        r0=rrr;
        
    end
    
    for t = 2:T
        y(:,t) = Qt(:,:,t) * y(:,t-1) + Gt(:,:,t) * eps(:,t);
        y_non(:,t) = Qt(:,:,t) * y_non(:,t-1);
    end
    
    bigYcom(:,:,i_) = y_com;
    bigYre(:,:,i_)  = y;
    bigYnon(:,:,i_) = y_non;
    
end

    
  % Store Simulated Paths
out.simul.Ycom = bigYcom;
out.simul.Y  =  bigYre;
out.simul.Ynon = bigYnon;



disp('Done!')