% Table 7 Data

SET.options.country = 'USA';
runSet;
SET.options.T       = 150; % Length of the simulation

N_ = 333; % number of simulations. 


% Postions in XX_
inflation        = 1;
output_growth    = 2;

% Position in XX_RE
%
X_ppi = zeros(SET.options.T,N_);
X_g   = zeros(SET.options.T,N_);
XX_    = zeros(N_,4); % [SR, Dppi, Peak, Duration];


lambda_values = 0.5;

state = 10;
SET.options.randnstate = state;
rand('state',state);
actual_DeltaPPI = 2+chi2rnd(5,N_,1);
prob_usa = 1;


l_ = 0;

for j_ = 1:N_
    
    
    if rand < prob_usa
        SET.options.country = 'USA';
        country_id = 1; % USA = 1;
        runSet;
        SET.param.ppibar    = 20/400 ;
        SET.param.Delta_ppi = actual_DeltaPPI(j_) ;
        SET.options.T       = 150; % Length of the simulation
        SET.options.T_star  = 70;  % Date of the regime change. 
        SET.options.T_a     = 68;  % Date of announcement. Date agents know of the forthcoming structural change.
    else
        SET.options.country = 'Argentina';
        country_id = 2; % ARG = 2;
        runSet;
        SET.param.ppibar    = 20/400 ;
        SET.param.Delta_ppi = actual_DeltaPPI(j_) ;
        SET.options.T       = 150; % Length of the simulation
        SET.options.T_star  = 70;  % Date of the regime change. 
        SET.options.T_a     = 68;  % Date of announcement. Date agents know of the forthcoming structural change.
    end
    
    SET.param.lambda = lambda_values;
    SET.options.randnstate = state+j_;
    
    out = SR_reg(SET);
    

    X_ppi(:,j_) = out.simul.Ycom(SET.variable.ppi,:,1);
    X_g(:,j_) = out.simul.Ycom(SET.variable.g,:,1);


    out = SR_Actual(SET);
    
    XX_(j_,:) = [out.SR.Ycom.draws, actual_DeltaPPI(j_), out.peak.Ycom, out.Duration.Ycom]; 
    
    disp(100*j_/N_);
    
end

X_ppi = 400*X_ppi';
csvwrite('simINF_L05.csv',X_ppi)

X_g = 400*X_g';
csvwrite('simG_L05.csv',X_g)

csvwrite('XX_L05.csv',XX_);

