* Argentina Data Cleaning
* Gibbs and Kulish
* Created: 27/10/2014
* Modified: 8/8/2017

*** GDP
clear

*set appropriate directory
cd "CHANGE DIRECTORY BEFORE USE/Data"


import excel "SGE-ARGGGR.xls", sheet("Sheet1") cellrange(B2:B86)

gen quarter = tq(1993q1) + _n

tsset quarter, quarterly

rename B  sa_gdp

replace sa_gdp = sa_gdp/100

sort quarter


save argentina_gdp_final, replace

* Money

clear

import excel "MoneyMeasures.xls", sheet("M0") cellrange(A28:G1001)

drop if B==" "
drop if G==.

drop B C D E F 
drop if A=="1940.06"

egen tempquarter=seq(), block(3)


collapse G, by(tempquarter)

gen quarter = tq(1940q2)+_n

tsset quarter, quarterly

drop if quarter==tq(2014q3)

drop temp

sort quarter

rename G m0

save argentina_money, replace

* Prices

clear

import excel "Official Price Data sh_ipc_2008.xls", sheet("Serie Histrica") cellrange(A6:AV857)

keep A B C

destring C, replace

egen tempquarter=seq(), block(3)

collapse C, by(tempqua)

gen quarter = tq(1942q4) + _n

drop tempq

rename C cpi

tsset quarter, quarterly

sort quarter

save argentina_price, replace

clear

import excel "Price Stats Billion Prices Argentina_monthly_series.xlsx", sheet("Argentina_monthly_series (1).cs") firstrow

gen date = td(30nov2007)+_n

gen dq = qofd(date)

collapse Argen, by(dq)

gen quarter = tq(2007q2)+_n

tsset quarter, quarterly

drop dq

rename Argen actual_cpi

sort quarter

save argentina_actual_price, replace

* Interest Rates

clear

import excel "MoneyMeasures.xls", sheet("Interest Rates") cellrange(A537:AK1001)

keep A B AK

drop if B==""

drop if A=="2010.13"

gen date = tm(1979m2)+_n

drop if date==230

egen tempq=seq(), block(3)

destring AK, replace force

rename AK interest_rate

collapse interest, by(tempq)

gen quarter= tq(1979q1)+_n

tsset quarter, quarterly

drop tempq 

sort quarter

save argentina_interest_rates, replace

*****************************************************************************
* Combing all data

use argentina_money, clear

order quarter m0

merge 1:1 quarter using argentina_interest_rates

drop _merge

sort quarter

merge 1:1 quarter using argentina_actual_price

drop _merge

sort quarter

merge 1:1 quarter using argentina_price

drop _merge

sort quarter

merge 1:1 quarter using argentina_gdp_final

drop _merge 

sort quarter

******************************************************************************
* Final Conversions and Data Clearning

* Inflation expressed at an annual rate
gen gov_inflation = (ln(cpi) - ln(l.cpi))
gen bpp_inflation = actual/40
replace bpp_inflation = gov_inflation if bpp ==.

* Money growth
gen money_growth = (ln(m0) - ln(l.m0))

* gdp_growth expressed as annual rate
gen gdp_growth = sa_gdp


egen bpp_mean=mean(bpp_inflation) if quarter>=tq(2003q1) & quarter<=tq(2014q2)
*replace bpp_inflation = bpp_inflation - bpp_mean

egen money_mean = mean(money_growth) if quarter>=tq(2003q1) & quarter<=tq(2014q2)
*replace money_growth = money_growth - money_mean

egen gdp_mean =mean(gdp_g) if quarter>=tq(2003q1) & quarter<=tq(2014q2)
*replace gdp_g = gdp_g - gdp_mean

replace interest_rate = ln((interest_rate/100 + 1)^(1/4))
*replace interest_rate = ln(interest_rate/100 + 1) /400
egen interest_mean = mean(interest_rate) if quarter>=tq(2003q1) & quarter<=tq(2014q2)
*replace interest_rate = interest_rate - interest_mean

* Export data for Dynare Estimation

export excel using "Argentina_Data_Clean", firstrow(variables) datestring("%tq") replace
